<html>
<head>
<title>OgreSharedPtr.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSharedPtr.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSharedPtr_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __SharedPtr_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __SharedPtr_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a">00042</a>     <span class="keyword">enum</span> <a class="code" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a" title="The method to use to free memory on destruction.">SharedPtrFreeMethod</a>
<a name="l00043"></a>00043     {
<a name="l00045"></a><a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd">00045</a>         <a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd" title="Use OGRE_DELETE to free the memory.">SPFM_DELETE</a>,
<a name="l00047"></a><a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aab7cd87e656cd7fd3b9cd1345d03822d7">00047</a>         <a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aab7cd87e656cd7fd3b9cd1345d03822d7" title="Use OGRE_DELETE_T to free (only MEMCATEGORY_GENERAL supported)">SPFM_DELETE_T</a>,
<a name="l00049"></a><a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadfed108573922359d60810b2aaf2d54b">00049</a>         <a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadfed108573922359d60810b2aaf2d54b" title="Use OGRE_FREE to free (only MEMCATEGORY_GENERAL supported)">SPFM_FREE</a>
<a name="l00050"></a>00050     };
<a name="l00051"></a>00051 
<a name="l00060"></a><a class="code" href="classOgre_1_1SharedPtr.html">00060</a>     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062     <span class="keyword">protected</span>:
<a name="l00063"></a><a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">00063</a>         T* <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>;
<a name="l00064"></a><a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">00064</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">00065</a>         <a class="code" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a" title="The method to use to free memory on destruction.">SharedPtrFreeMethod</a> <a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>; <span class="comment">// if we should use OGRE_FREE instead of OGRE_DELETE</span>
<a name="l00066"></a>00066     <span class="keyword">public</span>:
<a name="l00067"></a>00067         <a class="code" href="OgrePrerequisites_8h.html#ab0e8c6d123555d7447c38185a1b9105e">OGRE_AUTO_SHARED_MUTEX</a> <span class="comment">// public to allow external locking</span>
<a name="l00072"></a><a class="code" href="classOgre_1_1SharedPtr.html#ae46c7b984c057d18d8bd169cf2a60fad">00072</a> <span class="comment"></span>        <a class="code" href="classOgre_1_1SharedPtr.html#ae46c7b984c057d18d8bd169cf2a60fad" title="Constructor, does not initialise the SharedPtr.">SharedPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>(0), <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>(0), <a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>(<a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd" title="Use OGRE_DELETE to free the memory.">SPFM_DELETE</a>)
<a name="l00073"></a>00073         {
<a name="l00074"></a>00074             <a class="code" href="OgrePrerequisites_8h.html#a053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00075"></a>00075         }
<a name="l00076"></a>00076 
<a name="l00081"></a>00081         <span class="keyword">template</span>&lt; <span class="keyword">class</span> Y&gt;
<a name="l00082"></a><a class="code" href="classOgre_1_1SharedPtr.html#a9daf742e1f2c363bdcaccff255f2dd2d">00082</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1SharedPtr.html#ae46c7b984c057d18d8bd169cf2a60fad" title="Constructor, does not initialise the SharedPtr.">SharedPtr</a>(Y* rep, <a class="code" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a" title="The method to use to free memory on destruction.">SharedPtrFreeMethod</a> inFreeMethod = <a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd" title="Use OGRE_DELETE to free the memory.">SPFM_DELETE</a>) 
<a name="l00083"></a>00083             : <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>(rep)
<a name="l00084"></a>00084             , <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>(rep ? <a class="code" href="group__Memory.html#ga46253f12658ce0922e982a8a9dd11312" title="Allocate space for one primitive type, external type or non-virtual type with constructor parameters...">OGRE_NEW_T</a>(unsigned int, <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb" title="General purpose.">MEMCATEGORY_GENERAL</a>)(1) : 0)
<a name="l00085"></a>00085             , <a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>(inFreeMethod)
<a name="l00086"></a>00086         {
<a name="l00087"></a>00087             <a class="code" href="OgrePrerequisites_8h.html#a053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00088"></a>00088             <span class="keywordflow">if</span> (rep)
<a name="l00089"></a>00089             {
<a name="l00090"></a>00090                 <a class="code" href="OgrePrerequisites_8h.html#a9ea1b6f845efd15c581b914ac84b93a3">OGRE_NEW_AUTO_SHARED_MUTEX</a>
<a name="l00091"></a>00091             }
<a name="l00092"></a>00092         }
<a name="l00093"></a><a class="code" href="classOgre_1_1SharedPtr.html#ab1fae2b13ec9cb470b4616c56cb599d8">00093</a>         <a class="code" href="classOgre_1_1SharedPtr.html#ae46c7b984c057d18d8bd169cf2a60fad" title="Constructor, does not initialise the SharedPtr.">SharedPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&amp; r)
<a name="l00094"></a>00094             : <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>(0), <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>(0), <a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>(<a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd" title="Use OGRE_DELETE to free the memory.">SPFM_DELETE</a>)
<a name="l00095"></a>00095         {
<a name="l00096"></a>00096             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00097"></a>00097             
<a name="l00098"></a>00098             <a class="code" href="OgrePrerequisites_8h.html#a053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00099"></a>00099             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00100"></a>00100             {
<a name="l00101"></a>00101                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00102"></a>00102                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00103"></a>00103                 <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>;
<a name="l00104"></a>00104                 <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>; 
<a name="l00105"></a>00105                 <a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>;
<a name="l00106"></a>00106                 <span class="comment">// Handle zero pointer gracefully to manage STL containers</span>
<a name="l00107"></a>00107                 <span class="keywordflow">if</span>(<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>)
<a name="l00108"></a>00108                 {
<a name="l00109"></a>00109                     ++(*pUseCount); 
<a name="l00110"></a>00110                 }
<a name="l00111"></a>00111             }
<a name="l00112"></a>00112         }
<a name="l00113"></a><a class="code" href="classOgre_1_1SharedPtr.html#a1ce00b90526a205ae31268a88bc9ed35">00113</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&amp; <a class="code" href="classOgre_1_1SharedPtr.html#a1ce00b90526a205ae31268a88bc9ed35">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&amp; r) {
<a name="l00114"></a>00114             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> == r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>)
<a name="l00115"></a>00115                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00116"></a>00116             <span class="comment">// Swap current data into a local copy</span>
<a name="l00117"></a>00117             <span class="comment">// this ensures we deal with rhs and this being dependent</span>
<a name="l00118"></a>00118             <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;T&gt;</a> tmp(r);
<a name="l00119"></a>00119             <a class="code" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">swap</a>(tmp);
<a name="l00120"></a>00120             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00121"></a>00121         }
<a name="l00122"></a>00122         
<a name="l00123"></a>00123         <span class="keyword">template</span>&lt; <span class="keyword">class</span> Y&gt;
<a name="l00124"></a><a class="code" href="classOgre_1_1SharedPtr.html#ad9ac8d216452366004f13221074ea906">00124</a>         <a class="code" href="classOgre_1_1SharedPtr.html#ae46c7b984c057d18d8bd169cf2a60fad" title="Constructor, does not initialise the SharedPtr.">SharedPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;Y&gt;</a>&amp; r)
<a name="l00125"></a>00125             : <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>(0), <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>(0), <a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>(<a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd" title="Use OGRE_DELETE to free the memory.">SPFM_DELETE</a>)
<a name="l00126"></a>00126         {
<a name="l00127"></a>00127             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00128"></a>00128 
<a name="l00129"></a>00129             <a class="code" href="OgrePrerequisites_8h.html#a053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00130"></a>00130             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00131"></a>00131             {
<a name="l00132"></a>00132                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00133"></a>00133                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00134"></a>00134                 <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>();
<a name="l00135"></a>00135                 <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00136"></a>00136                 <a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a> = r.<a class="code" href="classOgre_1_1SharedPtr.html#a2d8365d61e610b98e0d36d514ab29017">freeMethod</a>();
<a name="l00137"></a>00137                 <span class="comment">// Handle zero pointer gracefully to manage STL containers</span>
<a name="l00138"></a>00138                 <span class="keywordflow">if</span>(<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>)
<a name="l00139"></a>00139                 {
<a name="l00140"></a>00140                     ++(*pUseCount);
<a name="l00141"></a>00141                 }
<a name="l00142"></a>00142             }
<a name="l00143"></a>00143         }
<a name="l00144"></a>00144         <span class="keyword">template</span>&lt; <span class="keyword">class</span> Y&gt;
<a name="l00145"></a><a class="code" href="classOgre_1_1SharedPtr.html#a291dacc84f7f971399a37f725003e9df">00145</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&amp; <a class="code" href="classOgre_1_1SharedPtr.html#a291dacc84f7f971399a37f725003e9df">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;Y&gt;</a>&amp; r) {
<a name="l00146"></a>00146             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> == r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>())
<a name="l00147"></a>00147                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00148"></a>00148             <span class="comment">// Swap current data into a local copy</span>
<a name="l00149"></a>00149             <span class="comment">// this ensures we deal with rhs and this being dependent</span>
<a name="l00150"></a>00150             <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;T&gt;</a> tmp(r);
<a name="l00151"></a>00151             <a class="code" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">swap</a>(tmp);
<a name="l00152"></a>00152             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00153"></a>00153         }
<a name="l00154"></a><a class="code" href="classOgre_1_1SharedPtr.html#a3677e6904cd453e75b9b352ffe32f99d">00154</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html#a3677e6904cd453e75b9b352ffe32f99d">~SharedPtr</a>() {
<a name="l00155"></a>00155             <a class="code" href="classOgre_1_1SharedPtr.html#aa9225d4dac90501b6a5f0b2b49ea2eed">release</a>();
<a name="l00156"></a>00156         }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="classOgre_1_1SharedPtr.html#a6c7563f3047bcd454dffae2b297a87a1">00159</a>         <span class="keyword">inline</span> T&amp; <a class="code" href="classOgre_1_1SharedPtr.html#a6c7563f3047bcd454dffae2b297a87a1">operator*</a>()<span class="keyword"> const </span>{ assert(<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>); <span class="keywordflow">return</span> *<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>; }
<a name="l00160"></a><a class="code" href="classOgre_1_1SharedPtr.html#a756cec152c2db605fe7424da7f8e879b">00160</a>         <span class="keyword">inline</span> T* <a class="code" href="classOgre_1_1SharedPtr.html#a756cec152c2db605fe7424da7f8e879b">operator-&gt;</a>()<span class="keyword"> const </span>{ assert(<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>); <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>; }
<a name="l00161"></a><a class="code" href="classOgre_1_1SharedPtr.html#a2c3ed4a7b5574c4e53adec450fd537b0">00161</a>         <span class="keyword">inline</span> T* <span class="keyword">get</span>() <span class="keyword">const</span> { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>; }
<a name="l00162"></a>00162 
<a name="l00167"></a><a class="code" href="classOgre_1_1SharedPtr.html#ac8d90e023455dc3299f48722e6068e4a">00167</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#ac8d90e023455dc3299f48722e6068e4a" title="Binds rep to the SharedPtr.">bind</a>(T* rep, <a class="code" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a" title="The method to use to free memory on destruction.">SharedPtrFreeMethod</a> inFreeMethod = <a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd" title="Use OGRE_DELETE to free the memory.">SPFM_DELETE</a>) {
<a name="l00168"></a>00168             assert(!<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> &amp;&amp; !<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>);
<a name="l00169"></a>00169             <a class="code" href="OgrePrerequisites_8h.html#a9ea1b6f845efd15c581b914ac84b93a3">OGRE_NEW_AUTO_SHARED_MUTEX</a>
<a name="l00170"></a>00170             <a class="code" href="OgrePrerequisites_8h.html#a062b6df8793a5440c06a9056ff1c8fe9">OGRE_LOCK_AUTO_SHARED_MUTEX</a>
<a name="l00171"></a>00171             <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a> = <a class="code" href="group__Memory.html#ga46253f12658ce0922e982a8a9dd11312" title="Allocate space for one primitive type, external type or non-virtual type with constructor parameters...">OGRE_NEW_T</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb" title="General purpose.">MEMCATEGORY_GENERAL</a>)(1);
<a name="l00172"></a>00172             <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> = rep;
<a name="l00173"></a>00173             <a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a> = inFreeMethod;
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175 
<a name="l00176"></a><a class="code" href="classOgre_1_1SharedPtr.html#acd2b97578b72dd4abc33471a93ca4b91">00176</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SharedPtr.html#acd2b97578b72dd4abc33471a93ca4b91">unique</a>()<span class="keyword"> const </span>{ <a class="code" href="OgrePrerequisites_8h.html#a062b6df8793a5440c06a9056ff1c8fe9">OGRE_LOCK_AUTO_SHARED_MUTEX</a> assert(<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>); <span class="keywordflow">return</span> *<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a> == 1; }
<a name="l00177"></a><a class="code" href="classOgre_1_1SharedPtr.html#a29e90ed7b4339cce1cc7e6be919e78bb">00177</a>         <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1SharedPtr.html#a29e90ed7b4339cce1cc7e6be919e78bb">useCount</a>()<span class="keyword"> const </span>{ <a class="code" href="OgrePrerequisites_8h.html#a062b6df8793a5440c06a9056ff1c8fe9">OGRE_LOCK_AUTO_SHARED_MUTEX</a> assert(<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>); <span class="keywordflow">return</span> *<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>; }
<a name="l00178"></a><a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">00178</a>         <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* <a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>; }
<a name="l00179"></a>00179 
<a name="l00180"></a><a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">00180</a>         <span class="keyword">inline</span> T* <a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>; }
<a name="l00181"></a><a class="code" href="classOgre_1_1SharedPtr.html#a2d8365d61e610b98e0d36d514ab29017">00181</a>         <span class="keyword">inline</span> <a class="code" href="group__General.html#ga3970484e048d1352a7e59b61186b5f2a" title="The method to use to free memory on destruction.">SharedPtrFreeMethod</a> <a class="code" href="classOgre_1_1SharedPtr.html#a2d8365d61e610b98e0d36d514ab29017">freeMethod</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>; }
<a name="l00182"></a>00182 
<a name="l00183"></a><a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">00183</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> == 0; }
<a name="l00184"></a>00184 
<a name="l00185"></a><a class="code" href="classOgre_1_1SharedPtr.html#ae23c79e49621afdb17fc32f30519859f">00185</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#ae23c79e49621afdb17fc32f30519859f">setNull</a>(<span class="keywordtype">void</span>) { 
<a name="l00186"></a>00186             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>)
<a name="l00187"></a>00187             {
<a name="l00188"></a>00188                 <span class="comment">// can&#39;t scope lock mutex before release in case deleted</span>
<a name="l00189"></a>00189                 <a class="code" href="classOgre_1_1SharedPtr.html#aa9225d4dac90501b6a5f0b2b49ea2eed">release</a>();
<a name="l00190"></a>00190                 <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a> = 0;
<a name="l00191"></a>00191                 <a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a> = 0;
<a name="l00192"></a>00192             }
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195     <span class="keyword">protected</span>:
<a name="l00196"></a>00196 
<a name="l00197"></a><a class="code" href="classOgre_1_1SharedPtr.html#aa9225d4dac90501b6a5f0b2b49ea2eed">00197</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#aa9225d4dac90501b6a5f0b2b49ea2eed">release</a>(<span class="keywordtype">void</span>)
<a name="l00198"></a>00198         {
<a name="l00199"></a>00199             <span class="keywordtype">bool</span> destroyThis = <span class="keyword">false</span>;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201             <span class="comment">/* If the mutex is not initialized to a non-zero value, then</span>
<a name="l00202"></a>00202 <span class="comment">               neither is pUseCount nor pRep.</span>
<a name="l00203"></a>00203 <span class="comment">             */</span>
<a name="l00204"></a>00204 
<a name="l00205"></a>00205             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(<a class="code" href="OgrePrerequisites_8h.html#ab5230fc97085f9d074db2e47a4fd93d4">OGRE_AUTO_MUTEX_NAME</a>)
<a name="l00206"></a>00206             {
<a name="l00207"></a>00207                 <span class="comment">// lock own mutex in limited scope (must unlock before destroy)</span>
<a name="l00208"></a>00208                 <a class="code" href="OgrePrerequisites_8h.html#a062b6df8793a5440c06a9056ff1c8fe9">OGRE_LOCK_AUTO_SHARED_MUTEX</a>
<a name="l00209"></a>00209                 <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>)
<a name="l00210"></a>00210                 {
<a name="l00211"></a>00211                     <span class="keywordflow">if</span> (--(*<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>) == 0) 
<a name="l00212"></a>00212                     {
<a name="l00213"></a>00213                         destroyThis = <span class="keyword">true</span>;
<a name="l00214"></a>00214                     }
<a name="l00215"></a>00215                 }
<a name="l00216"></a>00216             }
<a name="l00217"></a>00217             <span class="keywordflow">if</span> (destroyThis)
<a name="l00218"></a>00218                 <a class="code" href="classOgre_1_1SharedPtr.html#afaba3332d99634ccbacef674fc46b773">destroy</a>();
<a name="l00219"></a>00219 
<a name="l00220"></a>00220             <a class="code" href="OgrePrerequisites_8h.html#a053475f75a35e320fa019cf083ba8918">OGRE_SET_AUTO_SHARED_MUTEX_NULL</a>
<a name="l00221"></a>00221         }
<a name="l00222"></a>00222 
<a name="l00223"></a><a class="code" href="classOgre_1_1SharedPtr.html#afaba3332d99634ccbacef674fc46b773">00223</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#afaba3332d99634ccbacef674fc46b773">destroy</a>(<span class="keywordtype">void</span>)
<a name="l00224"></a>00224         {
<a name="l00225"></a>00225             <span class="comment">// IF YOU GET A CRASH HERE, YOU FORGOT TO FREE UP POINTERS</span>
<a name="l00226"></a>00226             <span class="comment">// BEFORE SHUTTING OGRE DOWN</span>
<a name="l00227"></a>00227             <span class="comment">// Use setNull() before shutdown or make sure your pointer goes</span>
<a name="l00228"></a>00228             <span class="comment">// out of scope before OGRE shuts down to avoid this.</span>
<a name="l00229"></a>00229             <span class="keywordflow">switch</span>(<a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>)
<a name="l00230"></a>00230             {
<a name="l00231"></a>00231             <span class="keywordflow">case</span> <a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadae32e4e84712917731325c903fa14dd" title="Use OGRE_DELETE to free the memory.">SPFM_DELETE</a>:
<a name="l00232"></a>00232                 <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> <a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>;
<a name="l00233"></a>00233                 <span class="keywordflow">break</span>;
<a name="l00234"></a>00234             <span class="keywordflow">case</span> <a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aab7cd87e656cd7fd3b9cd1345d03822d7" title="Use OGRE_DELETE_T to free (only MEMCATEGORY_GENERAL supported)">SPFM_DELETE_T</a>:
<a name="l00235"></a>00235                 <a class="code" href="group__Memory.html#ga0b0974da65362dd8a14071e7f6e4daca" title="Free the memory allocated with OGRE_NEW_T. Category is required to be restated to ensure the matching...">OGRE_DELETE_T</a>(pRep, T, <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb" title="General purpose.">MEMCATEGORY_GENERAL</a>);
<a name="l00236"></a>00236                 <span class="keywordflow">break</span>;
<a name="l00237"></a>00237             <span class="keywordflow">case</span> <a class="code" href="group__General.html#gga3970484e048d1352a7e59b61186b5f2aadfed108573922359d60810b2aaf2d54b" title="Use OGRE_FREE to free (only MEMCATEGORY_GENERAL supported)">SPFM_FREE</a>:
<a name="l00238"></a>00238                 <a class="code" href="group__Memory.html#gacfd8dc937cf390c7bff05495f0dc10cf" title="Free the memory allocated with OGRE_MALLOC or OGRE_ALLOC_T. Category is required to be restated to en...">OGRE_FREE</a>(pRep, <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb" title="General purpose.">MEMCATEGORY_GENERAL</a>);
<a name="l00239"></a>00239                 <span class="keywordflow">break</span>;
<a name="l00240"></a>00240             };
<a name="l00241"></a>00241             <span class="comment">// use OGRE_FREE instead of OGRE_DELETE_T since &#39;unsigned int&#39; isn&#39;t a destructor</span>
<a name="l00242"></a>00242             <span class="comment">// we only used OGRE_NEW_T to be able to use constructor</span>
<a name="l00243"></a>00243             <a class="code" href="group__Memory.html#gacfd8dc937cf390c7bff05495f0dc10cf" title="Free the memory allocated with OGRE_MALLOC or OGRE_ALLOC_T. Category is required to be restated to en...">OGRE_FREE</a>(<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>, <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb" title="General purpose.">MEMCATEGORY_GENERAL</a>);
<a name="l00244"></a>00244             <a class="code" href="OgrePrerequisites_8h.html#a8b873e0e48fc343f9553e1dc526ff6f3">OGRE_DELETE_AUTO_SHARED_MUTEX</a>
<a name="l00245"></a>00245         }
<a name="l00246"></a>00246 
<a name="l00247"></a><a class="code" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">00247</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">swap</a>(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;T&gt;</a> &amp;other) 
<a name="l00248"></a>00248         {
<a name="l00249"></a>00249             <a class="code" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">std::swap</a>(<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>, other.<a class="code" href="classOgre_1_1SharedPtr.html#a8a5094cabd90223647525fe162e94e57">pRep</a>);
<a name="l00250"></a>00250             <a class="code" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">std::swap</a>(<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>, other.<a class="code" href="classOgre_1_1SharedPtr.html#a52f9915e259723090662cca7c3c51d52">pUseCount</a>);
<a name="l00251"></a>00251             <a class="code" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">std::swap</a>(<a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>, other.<a class="code" href="classOgre_1_1SharedPtr.html#a81eed90dd7d087f03cd010167d91f33e">useFreeMethod</a>);
<a name="l00252"></a>00252 <span class="preprocessor">#if OGRE_THREAD_SUPPORT</span>
<a name="l00253"></a>00253 <span class="preprocessor"></span>            <a class="code" href="classOgre_1_1SharedPtr.html#af07cad7e719e517472410d87f4e974ea">std::swap</a>(<a class="code" href="OgrePrerequisites_8h.html#ab5230fc97085f9d074db2e47a4fd93d4">OGRE_AUTO_MUTEX_NAME</a>, other.OGRE_AUTO_MUTEX_NAME);
<a name="l00254"></a>00254 <span class="preprocessor">#endif</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span>        }
<a name="l00256"></a>00256     };
<a name="l00257"></a>00257 
<a name="l00258"></a><a class="code" href="group__General.html#ga9e4eed9f10776cc5b07cd81082d73dc8">00258</a>     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T, <span class="keyword">class</span> U&gt; <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;T&gt;</a> <span class="keyword">const</span>&amp; a, <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;U&gt;</a> <span class="keyword">const</span>&amp; b)
<a name="l00259"></a>00259     {
<a name="l00260"></a>00260         <span class="keywordflow">return</span> a.<a class="code" href="classOgre_1_1SharedPtr.html#a2c3ed4a7b5574c4e53adec450fd537b0">get</a>() == b.<a class="code" href="classOgre_1_1SharedPtr.html#a2c3ed4a7b5574c4e53adec450fd537b0">get</a>();
<a name="l00261"></a>00261     }
<a name="l00262"></a>00262 
<a name="l00263"></a><a class="code" href="group__General.html#ga000fe08e9240733ce1630abe43839e39">00263</a>     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T, <span class="keyword">class</span> U&gt; <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!=</a>(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;T&gt;</a> <span class="keyword">const</span>&amp; a, <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;U&gt;</a> <span class="keyword">const</span>&amp; b)
<a name="l00264"></a>00264     {
<a name="l00265"></a>00265         <span class="keywordflow">return</span> a.<a class="code" href="classOgre_1_1SharedPtr.html#a2c3ed4a7b5574c4e53adec450fd537b0">get</a>() != b.<a class="code" href="classOgre_1_1SharedPtr.html#a2c3ed4a7b5574c4e53adec450fd537b0">get</a>();
<a name="l00266"></a>00266     }
<a name="l00267"></a>00267 
<a name="l00268"></a><a class="code" href="group__General.html#gae1dbf4506ab2500da5ec4ef0b58cb2e1">00268</a>     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T, <span class="keyword">class</span> U&gt; <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator&lt;(SharedPtr&lt;T&gt; <span class="keyword">const</span>&amp; a, <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;U&gt;</a> <span class="keyword">const</span>&amp; b)
<a name="l00269"></a>00269     {
<a name="l00270"></a>00270         <span class="keywordflow">return</span> std::less&lt;const void*&gt;()(a.get(), b.get());
<a name="l00271"></a>00271     }
<a name="l00274"></a>00274 }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
